-- Fatorial

fat :: Int -> Int
fat n
    | n==0 = 1
    | otherwise = (fat (n-1) * n)
    
-- All4Equal
all4Equal :: Int -> Int -> Int -> Int -> Bool
all4Equal a b c d
    |   (a==b) && (b==c) && (c==d) = True
    |   otherwise = False
    
-- HowManyEqual
howManyEqual :: Int -> Int -> Int -> Int
howManyEqual a b c
    |       (a==b) && (b==c) = 3
    |       (a == b) || (a==c) || (b==c) = 2
    |       otherwise = 0
    
--sales
sales :: Int -> Int
sales n
    | n==1 = 21
    | n==2 = 12
    | n==3 = 43
    | n==4 = 87
    | n==5 = 12
    | n==6 = 11
    | n==7 = 35

-- Total Sales
totalSales :: Int -> Int
totalSales n
    |   n==1 = sales n
    |   n < 1 || n > 7 = -1
    |   otherwise = (totalSales (n-1)) + sales n

--maxi
maxi :: Int -> Int -> Int
maxi a b
    |  a > b = a
    | otherwise = b

-- maxSales
maxSales :: Int -> Int
maxSales n
    |   n==1 = sales n
    |   n < 1 || n > 7 = -1
    |   otherwise = maxi( maxSales(n-1)) (sales n)

--check ( Auxiliar para a funo seguinte)
check :: Int -> Int -> Int -> Int
check s n t
    |   n < 1 || n > 7 = t
    |   (sales n)==s = check s (n-1) t+1
    |   otherwise = check s (n-1) t

--checkSales
checkSales :: Int -> Int -> Int
checkSales s n
    | (n < 1 || n > 7) = -1
    | otherwise = check s n 0

--make ( auxiliar da funcao seguinte)
make :: Int -> String -> String
make i s
    | i==0 = s
    | otherwise = make (i-1) (" " ++ s)

-- makeSpaces
makeSpaces :: Int -> String
makeSpaces n
    | n < 1 = ""
    | otherwise = make n (" ")

-- pushRight
pushRight :: Int -> String -> String
pushRight i s
    | i < 1 = s
    | otherwise = make i s

-- averageSales
averageSales :: Int -> Float
averageSales n
    | n < 1 || n > 7 = -1
    | otherwise = fromInt (totalSales n)/ fromInt n

--sumlist
sumList :: [Int] -> Int
sumList  [] = 0
sumList (a:as) = a + sumList as


--zipp
zipp:: [t] -> [u] -> [(t,u)]
zipp [] [] = []
zipp (a:as) (b:bs) = (a,b):zip as bs

-- ############ LISTAS ############

--double
double :: [Int] -> [Int]
double [] = []
double (a:as) = 2*a:double as

-- membership
{-member :: [Int] -> Int -> Bool
member [] b = False
member (a:as) b  = (a==b) || member as b
-}
member :: [Int] -> Int -> Bool
member ls i = (ls == [l | l <-ls])


composicao :: ([(Int,Int)]-> [Int]) -> ([Int]->[Int]->[(Int,Int)]) -> [Int] -> [Int] -> [Int]
composicao f g a b = f (g a b)


sumZipp :: [Int] -> [Int] -> [Int]
sumZipp a b = (composicao sumpairs zipp) a b

--sumpairs
sumpairs :: [(Int,Int)] -> [Int]
sumpairs (a:as)
    |   as==[] = (fst a + snd a):[]
    |   otherwise = (fst a + snd a):sumpairs as

{- OUUUU
sumpairs :: [(Int,Int)] -> [Int]
sumpairs ((x,y):as)
    |   as==[] = (x+y):[]
    |   otherwise = (x+y):sumpairs as
-}

--digits
digits :: String -> String
digits st = [ ch | ch<-st , isDigit ch ]

-- firstDigit
firstdigit :: String -> Char
firstdigit st = case st of
                  []    -> '\0'
                  a:as  -> a

--biblioteca DATABASE [("Osmany","IA"),("Paulo", "BD"),("Osmany","Middleware"),("Maira","Redes")]
type Pessoa = String
type Livro = String
type BD = [(Pessoa, Livro)]

--Livros
{- livros :: BD -> Pessoa -> [Livro]
livros (d:bd) p = if p == fst d
                  then (snd d):livros bd p
                  else livros bd p
livros [] p     = []
-}
livros :: BD -> Pessoa -> [Livro]
livros bd f = [l | (p,l) <- bd , f == p]


--map

mappPair :: ((t,t) -> u) -> [(t,t)] -> [u]
mappPair f xs = [f x | x<-xs]
--mappPair f [] = []
--mappPair f (a:as) = (f fst a snd a): (map f as)

mapp :: (t->u) -> [t] -> [u]
mapp f as = [f a| a <- as]


sqrSin :: Int -> Int
sqrSin a = a*a

sqrPair :: (Int,Int) -> Int
sqrPair a = fst a * snd a

fold :: (t -> t -> t) -> [t] -> t
fold f [a] = a
fold f (a:as) = f a (fold f as)

andFold :: [Bool] -> Bool
andFold xs = fold (&&) xs


maximu :: [Int] -> Int
maximu xs = fold maxi xs



--
data Expr = Lit Int
          | Add Expr Expr
          | Sub Expr Expr

showExpr :: Expr -> String
showExpr(Lit a) = show (fromInt a)
showExpr(Add e1 e2) = "(" ++ (showExpr e1) ++ "+" ++ (showExpr e2) ++ ")"
showExpr(Sub e1 e2) = "(" ++ (showExpr e1) ++ "-" ++ (showExpr e2) ++")"

data List t = Nil
            | Cons t (List t)

--Cons 1(Cons 2(Cons 3))

--(Cons 1(Cons 2(Cons 3 (Nil))))

toList :: List t -> [t]
toList Nil  = []
toList (Cons t t1) = t:(toList t1)

fromList :: [t] -> List t
fromList [] = Nil
fromList (x:xs) = Cons x(fromList xs)

showLista :: List Int-> String
showLista Nil = ""
showLista (Cons t t1) = (show (fromInt t)) ++ "," ++ (showLista t1)

data Tree t = NilT
            | Node t (Tree t) (Tree t)

{-
collapse :: Tree t -> [t]
collapse NilT = []
collapse (Node t t1 t2) = t:collapse(t1):collapse(t2)
-}


















